/*============================================================================
                              PAIRS
Use of templates and classes.
=========================================================================== */
#include  <iostream.h> 
//----------------- template of pairs ----------------------------------------
template<class Type>
class pair
{Type f, s;
 public :
 pair(Type a, Type b) {f=a; s=b;}
 Type fst(){return f;}
 Type snd(){return s;}
};
//----------------- pairs of integers ----------------------------------------
class intpair
{int f, s;
 public :
 intpair(int a, int b) {f=a; s=b;}
 int intf(){return f;}
 int ints(){return s;}
};
//----------------------------------------------------------------------------
void main()
{pair<int> p(17,4);         // an instance of pairs of integers
cout << "\n17 = " << p.fst() << "\n4 = " << p.snd();
pair<int> * pp = &p;        // a pointer to the class pair<int>
cout << "\n17 = " << (*pp).fst();
//----------------------------------------------------------------------------
pair<bool> b(0,1);          // a instance of pairs of booleans
cout << "\n0 = " << b.fst() << "\n1 = " << b.snd();
pair<bool> * pb = &b;       // a pointer to the class pair<bool>
cout << "\n1 = " << (*pb).snd() << "\n\n";
//----------------------------------------------------------------------------
// pair< pair<bool> > d(b(0,1),b(0,1)); cout << "\n0 = " << (d.fst()).fst();
// IT DOES NOT WORK: the parameter cannot be an instantiated template!
//----------------------------------------------------------------------------
// intpair ii1(15,16); intpair ii2(25,26);
// pair<intpair> d(ii1,ii2); cout << "\n26 = " << (d.fst()).intf();
// IT DOES NOT WORK: the parameter cannot be a class!
//----------------------------------------------------------------------------
}
/* input:    output:
------------------------------------------------------------------------------
             17 = 17
             4 = 4
             17 = 17
             0 = 0
             1 = 1
             1 = 1
---------------------------------------------------------------------------- */